<?php
/*
// IIG - "Image Index Gallery" Plugin Joomla 1.5 - Version 1.6.015
// License: http://www.gnu.org/copyleft/gpl.html
// Author: Jens Fuchs
// Projectsite: http://www.xrheingauerx.de/IIG1.html
// (used Code from: SIGE - http://joomla-extensions.kubik-rubik.de/sige-simple-image-gallery-extended)
//
// @license GNU/GPL
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.event.plugin');

class plgContentIIG extends JPlugin {
	
	function plgContentIIG(&$subject) {
	  jimport('joomla.html.parameter');
		parent::__construct($subject);
		$this->_plugin = JPluginHelper::getPlugin('content', 'iig');
		$this->_params = new JParameter($this->_plugin->params);
		if (isset($_SESSION["iigcount"])) {
			unset($_SESSION["iigcount"]);
		}
		if (isset($_SESSION["iigcountarticles"])) {
			unset($_SESSION["iigcountarticles"]);
		}
		// Sprache aus Administrator einlesen
		$this->loadLanguage('plg_content_iig', JPATH_ADMINISTRATOR);
	}
	
	function onContentPrepare($context, &$article, &$params, $limitstart) {
	
		// Wenn Pluginsyntax nicht gefunden, nichts machen
		if (!preg_match("#{iig_gallery}(.*?){/iig_gallery}#s", $article->text)) {
			return;
		}	
		
		$plugin =& JPluginHelper::getPlugin('content', 'iig');
		$pluginParams = new JParameter($plugin->params);

		$mosConfig_absolute_path = JPATH_SITE;
		$mosConfig_live_site = JURI :: base();
		if (substr($mosConfig_live_site, -1) == "/")  {
			$mosConfig_live_site = substr($mosConfig_live_site, 0, -1);
		}
		
		// GD Test
		if (function_exists("gd_info")) {
			$gdinfo = gd_info();
			$gdsupport = array();
			$version = intval(preg_replace('/[[:alpha:][:space:]()]+/', '', $gdinfo['GD Version']));
			if ($version!=2) $gdsupport[] = '<div class="iig_message">* '.JText::_('IIG_NOGD').'</div>';
			
			// PHP Versionsabfrage
			if (substr(phpversion(), 0, 3) < 5.3) 
			{
				if (!$gdinfo['JPG Support']) $gdsupport[] = '<div class="iig_message">* '.JText::_('IIG_NOGDJPG').'</div>';
			} 
			else 
			{
				if (!$gdinfo['JPEG Support']) $gdsupport[] = '<div class="iig_message">* '.JText::_('IIG_NOGDJPEG').'</div>';
			}
			if (!$gdinfo['GIF Create Support']) $gdsupport[] = '<div class="iig_message">* '.JText::_('IIG_NOGDGIF').'</div>';
			if (!$gdinfo['PNG Support']) $gdsupport[] = '<div class="iig_message">* '.JText::_('IIG_NOGDPNG').'</div>';
			if (count($gdsupport)) 
			{
				foreach ($gdsupport as $k=>$v) {echo $v;}
			}
		}		
		
		// Joomla Versionsabfrage
		$version = new JVersion();
		if ($version->PRODUCT == "Joomla!" AND $version->RELEASE != "1.6") {
			echo '<div class="iig_message">* '.JText::_('IIG_INVALIDVERSION').'</div>';
		}
		
		if (!isset($_SESSION["iigcountarticles"])) {
			$_SESSION["iigcountarticles"] = -1;
		}			
			
			
		// Suche nach Pluginsyntax
		if (preg_match_all("#{iig_gallery}(.*?){/iig_gallery}#s", $article->text, $matches, PREG_PATTERN_ORDER) > 0) {
			
      // Wenn Cache deaktiviert, werden alle Bilder gelscht und die Bilder werden wieder neu generiert
      $iig_images_cache = $pluginParams->get('iig_cache', '0');
      $images_path = $mosConfig_absolute_path.$rootfolder.'/images/iig/';
      $images_path_live = $mosConfig_live_site.'/images/iig/';
      if ( ! $iig_images_cache ) { rrmdir($images_path) ;}
      if ( ! is_dir($images_path) ) { mkdir($images_path, 0755) ;}
			
			$_SESSION["iigcountarticles"]++;			
			
			if (!isset($_SESSION["iigcount"])) 
			{
				$_SESSION["iigcount"] = 0;
			}
			
      $iig_css = "";			
			
      // Jede {igg_gallery} 
      foreach ($matches[0] as $match) 
      {			
        $_SESSION["iigcount"]++;
        
        $iig_tablename = preg_replace("/{.+?}/", "", $match);
        
        if ($iig_tablename == '') {
          
          echo '<div class="iig_message">* '.JText::_('IIG_NOTABLENAME').': '.($_SESSION["iigcount"]).'</div>';
          
        } else {
        
          $hash_tablename = tableHash($iig_tablename);
          
          // Bilder aus Datenbank ermitteln
          unset($images);
          $noimage = 0;				
      
          // Datenbank-Operationen
          $db = JFactory::getDBO();
          $query = 'SELECT ID, who, homepage FROM '.$iig_tablename.' ORDER BY ID DESC';
          $db->setQuery($query);
          //$images = $db->loadResultArray();
          $images = $db->loadObjectList();

          // Start der Ausgabe
          $html = '<!-- BEGINN Image Index Gallery - Plugin v1.6.015 - http://www.xrheingauerx.de/IIG1.html -->';

          if ($db->getErrorNum()) {
          
            $html .= '<div class="iig_message">* '.JText::_('IIG_DBERROR').': '.($_SESSION["iigcount"]).'</div>'; 
            //$html .= '<div class="iig_message">* '.JText::_('IIG_DBERROR').': '.($_SESSION["iigcount"]).' ('.$db->getErrorMsg().')</div>'; 
          
          } else {
          
             
            if (count($images) == 0) {
              
              $html .= '<strong>'.JText::_('IIG_NOIMAGES').'</strong>';
              
            } else {			
			
              // CSS fr jede Gallerie festlegen
              $iig_css .= ".iig_cont_".$_SESSION["iigcount"]." {width:".$pluginParams->get('iig_th_width', 60)."px;height:".$pluginParams->get('iig_th_height', 77)."px;float:left;}\n";
              
              $html .= '<span class="iig">';
              
              foreach ($images as $image) {
              
                // Prfen, ob Thumb schon vorhanden, sonst Images (Thumb und CSS) erzeugen
                $img = $images_path.$hash_tablename.$image->ID;
                if ( ! file_exists($img.'jpg') ) { 
                  createImages (($_SESSION["iigcount"]), $db, $iig_tablename, $image->ID, $img, $pluginParams); 
                }
                
                $img_live = $images_path_live.$hash_tablename.$image->ID;
                
                $homepage = $image->homepage;
                if ( $homepage == '' ) {
                  $homepage = 'title="Image Index Gallery use Slimbox" onmouseover="this.title=\'\'" onmouseout="this.title=\'Image Index Gallery use Slimbox\'" onclick="this.title=\'Image Index Gallery use Slimbox\'"';
                } else {
                  $homepage = str_ireplace ('http://','',$homepage);
                  if ( strtolower(substr($homepage,0,4)) != 'www.') {
                    $homepage = 'title="Image Index Gallery use Slimbox" onmouseover="this.title=\'\'" onmouseout="this.title=\'Image Index Gallery use Slimbox\'" onclick="this.title=\'Image Index Gallery use Slimbox\'"';
                  } else {
                    $homepage = 'title="&lt;a href=\'http://'.$homepage.'\' target=\'new\'&gt;'.$homepage.'&lt;/a&gt;" onmouseover="this.title=\'\'" onmouseout="this.title=\'&lt;a href=\\\'http://'.$homepage.'\\\' target=\\\'new\\\'&gt;'.$homepage.'&lt;/a&gt;\'" onclick="this.title=\'&lt;a href=\\\'http://'.$homepage.'\\\' target=\\\'new\\\'&gt;'.$homepage.'&lt;/a&gt;\'"';
                  }
                }
                
                $html .= '<span class="iig_cont_'.$_SESSION["iigcount"].'"><span class="iig_thumb">';
             
                if ( $pluginParams->get('iig_css_image', 1) ) {
                  $html .= '<a href="'.$img_live.'css.jpg" class="iig_css_image" rel="lightbox.iig'.$_SESSION["iigcount"].'" '.$homepage.'>';
                  $html .= '<img src="'.$img_live.'.jpg" alt="'.$image->who.'" title=""/>';                    
                  $html .= '<span><img src="'.$img_live.'css.jpg" title=""></span>';
                  $html .= '</a>';                  
                } else {
                  $html .= '<a href="'.$img_live.'css.jpg" '.$homepage.'">';
                  $html .= '<img src="'.$img_live.'.jpg" alt="'.$image->who.'" title="'.$image->who.'"/>';
                  $html .= '</a>';
                }
                
                $html .= '</span></span>';
              }
                
              $html .= '</span>';
              
              $html .="\n<span class=\"iig_clr\"></span>\n</span>\n";
               
            } // Ende NoImages
          } // Ende DBError

          // Ende der Ausgabe
          $html .= '<!-- END Image Index Gallery - Plugin v1.6.015 - http://www.xrheingauerx.de/JoomlaIIG.html -->';
         
          // Ausgabe der Galerie
          $article->text = preg_replace("#{iig_gallery}".$iig_tablename."{/iig_gallery}#s", $html, $article->text);
          
        } // Ende NoTableName
      } // Ende {igg_gallery}				
				
			// CSS- und JS-Dateien in den Head-Bereich schreiben 
			$js			= 0; //$pluginParams->get('js', 0);
			$lang = JFactory::getLanguage();
			$lang->getTag();
			
			$head = array();
			$head[] = "<style type='text/css'>\n".$iig_css."</style>";
			
			// JS nur einmal einlesen
			if ($_SESSION["iigcountarticles"] == 0)
			{
				$head[] = '<link rel="stylesheet" href="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/iig.css" type="text/css" media="screen" />';
				if ($js == 0) 
				{
				  if ($lang->getTag() == "de-DE") {
  					$head[] = '<script type="text/javascript" src="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/slimbox/slimbox.js"></script>';
				  } else {
				    $head[] = '<script type="text/javascript" src="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/slimbox/slimbox_en.js"></script>';
				  }
				  $head[] = '<link rel="stylesheet" href="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/slimbox/slimbox.css" type="text/css" media="screen" />';
				}
				if ($js == 1) 
				{
				  if ($lang->getTag() == "de-DE") {
					  $head[] = '<script type="text/javascript" src="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/lytebox/lytebox.js"></script>';
					} else {
					  $head[] = '<script type="text/javascript" src="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/lytebox/lytebox_en.js"></script>';
					}
					$head[] = '<link rel="stylesheet" href="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/lytebox/lytebox.css" type="text/css" media="screen" />';
				}
				if ($js == 2) 
				{
					if ($lang->getTag() == "de-DE") {
					  $head[] = '<script type="text/javascript" src="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/shadowbox/shadowbox.js"></script>';
					} else {
					  $head[] = '<script type="text/javascript" src="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/shadowbox/shadowbox_en.js"></script>';
					}
					$head[] = '<link rel="stylesheet" href="'.$mosConfig_live_site.'/plugins/content/iig/plugin_iig/shadowbox/shadowbox.css" type="text/css" media="screen" />';
					$head[] = '<script type="text/javascript">Shadowbox.init();</script>';
				}
			}
			$head = "\n".implode("\n", $head)."\n";
			$document = &JFactory::getDocument();
			$document->addCustomTag($head);
		
		}	// Ende Pluginsyntax
	
	} // Ende Funktion onContentPrepare
		
} // Ende Klasse plgContentIIG


  function rrmdir($dir) { 
    if (is_dir($dir)) { 
      $objects = scandir($dir); 
      foreach ($objects as $object) { 
        if ($object != "." && $object != "..") { 
          if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object); else unlink($dir."/".$object); 
        } 
      } 
      reset($objects); 
      rmdir($dir); 
    } 
  } 

  function tableHash($string) { 
    $salt = md5($string."%*4!#$;\.k~'(_@"); 
    $string = md5("$salt$string$salt"); 
    return $string; 
  } 

  // Creates Thumb and CSS Image
  function createImages($sess, $db, $table, $imgID, $imgPath, $pluginParams) {
    
//  mb_internal_encoding('UTF-8'); 
//  mysql_query("SET NAMES utf8"); 
//  mysql_query("SET CHARACTER SET utf8"); 
    
    
    //die(JFactory::getConfig());
     
    //$db->setUTF(0);
    //$db->Execute("SET CHARACTER SET ASCII"); 
    //$db->Execute("SET NAMES ASCII"); 
    
    $query = 'SELECT img, message, who FROM '.$table.' WHERE ID = '.$imgID;
    $db->setQuery($query);
    $image = $db->loadObject();

    if ($db->getErrorNum()) {
      echo '<div class="iig_message">* '.JText::_('IIG_DBERROR').': '.$sess.' image: '.$imgID.'</div>'; 
      //echo '<div class="iig_message">* '.JText::_('IIG_DBERROR').': '.$sess.' image: '.$imgID.' ('.$db->getErrorMsg().')</div>'; 
    } else {
    
      // Create Thumb
      $img = imagecreatefromstring($image->img);
      
      $width = $pluginParams->get('iig_th_width', 60);
      $height = $pluginParams->get('iig_th_height', 77);
      $ratio = $pluginParams->get('iig_ratio', 1);
      
      $img = imageResize ($img, $width, $height, $ratio);
      
      imagejpeg($img, $imgPath.'.jpg', $pluginParams->get('iig_th_quality', 80));
      
      imagedestroy($img);      
      
      // Create CSS
      $img = imagecreatefromstring($image->img);
      $mess = $image->message;
      $who = $image->who;

      $frame_image = ""; // Evtl. Background-Image
  
      $frame_width = $pluginParams->get('iig_css_image_framewidth', '350');
      $frame_height = intval(($frame_width * 52) / 100);
  
      $frame_bgcol_rgb = explode("-", $pluginParams->get('iig_css_image_framecol', '255-255-0'));
      $frame_bgcol_rgb[0] = intval($frame_bgcol_rgb[0]);
      $frame_bgcol_rgb[1] = intval($frame_bgcol_rgb[1]);
      $frame_bgcol_rgb[2] = intval($frame_bgcol_rgb[2]);      
  
      $gap_pictextframe = $pluginParams->get('iig_css_image_gapimgframe', '10');
      $pic_max = intval(($frame_width * 38.45) / 100);
      $pic_border = $pluginParams->get('iig_css_image_imgborderwidth', '3');
  
      $pic_border_col_rgb = explode("-", $pluginParams->get('iig_css_image_imgbordercol', '238-153-51'));
      $pic_border_col_rgb[0] = intval($pic_border_col_rgb[0]);
      $pic_border_col_rgb[1] = intval($pic_border_col_rgb[1]);
      $pic_border_col_rgb[2] = intval($pic_border_col_rgb[2]);
  
      $font_path = $pluginParams->get('iig_css_image_fontpath', '/usr/share/fonts/truetype/msttcorefonts/');
      $font = $font_path.$pluginParams->get('iig_css_image_fontfam_text', 'verdana.ttf');
      $font_size = $pluginParams->get('iig_css_image_fontfam_text_size', '11');
      $font_name = $font_path.$pluginParams->get('iig_css_image_fontfam_name', 'comic.ttf');
      $font_size_name = $pluginParams->get('iig_css_image_fontfam_name_size', '10');
      $font_angle = 0;
      $wordwrap_at = $pluginParams->get('iig_css_image_fontfam_text_wordwrap', '25');
      
      $checksize = 0; // Very slow, if it has to change the size often!!!

      // Photo
      $h = imageSY($img); 
      $w = imageSX($img);
      
      if ( $w > $pic_max ) {
        $img = imageResize($img, $pic_max - ($pic_border * 2) , $frame_height - ($pic_border * 2) - ($gap_pictextframe * 2), 1);
        $h = imageSY($img); 
        $w = imageSX($img);    
      }

      $img_photo = imagecreatetruecolor($w + ($pic_border * 2), $h + ($pic_border * 2));
      $bg = ImageColorAllocate ($img_photo, $pic_border_col_rgb[0], $pic_border_col_rgb[1], $pic_border_col_rgb[2]);
      imagefilledrectangle($img_photo, 0, 0, $w + ($pic_border * 2), $h + ($pic_border * 2), $bg);

      imagecopy ($img_photo, $img, $pic_border, $pic_border, 0, 0, $w, $h);

      // Text
      if ($frame_image == "") {
        $img = imagecreatetruecolor($frame_width, $frame_height);
        imagesavealpha($img, true);
        $trans_colour = imagecolorallocatealpha($img, 0, 0, 0, 127);
        $bg = ImageColorAllocate ($img, $frame_bgcol_rgb[0], $frame_bgcol_rgb[1], $frame_bgcol_rgb[2]);
        $font_color = ImageColorAllocate ($img, 0, 0, 0);
        imagefilledrectangle($img, 0, 0, $frame_width, $frame_height, $bg);
        //imagefill($img, 0, 0, $trans_colour);
      } else {
        //TODO
        // Hintergrund-Bild laden
      }

      $text_left = imageSX($img_photo) + ($gap_pictextframe * 2);
      $text_top = $gap_pictextframe + $font_size + 2;

      if ($checksize) {

        $text_maxwidth = $frame_width - ($gap_pictextframe * 3) - imageSX($img_photo);
        //$text_maxwidth = 200;
        
        $lines = explode('|', wordwrap(chr(34).$mess.chr(34), $wordwrap_at, '|', true));
        $linenew = implode ($lines,"\n");
        $linenew .= "\n\n".$who;
      
        $font_size ++;
        do {
          $font_size --;
          $arr = calculateTextBox($font_size, $font_angle, $font, $linenew) ;
        } while ($arr['width'] > $text_maxwidth || $arr['height'] > $frame_height - ($gap_pictextframe * 2));
        
        //die('TextMaxW:'.$text_maxwidth.' W: '.$arr['width'].' H: '.$arr['height']);
        
        imagettftext($img, $font_size, 0, $text_left, $text_top, $font_color, $font, entenc(utf8_decode($linenew)));    

      } else {
      
        $lines = explode('|', wordwrap(chr(34).$mess.chr(34), $wordwrap_at, '|', true));

        $linenew = implode ($lines,"\n");
        imagettftext($img, $font_size, 0, $text_left, $text_top, $font_color, $font, entenc(utf8_decode($linenew))); 
        
        $addme = 2;
        if ( $font_size > 12 ) {
          $addme = 3;
        }
        $text_top += ($font_size  * count($lines)) + ( (($font_size / 2) + $addme) * count($lines) );

        imagettftext($img, $font_size_name, 0, $text_left, $text_top + $font_size, $font_color, $font_name, entenc(utf8_decode($who)));
        //imagettftext($img, $font_size_name, 0, $text_left, $frame_height - $gap_pictextframe - 3, $font_color, $font_name, entenc(utf8_decode($who)));
      }
  
      ImageCopy ($img, $img_photo, $gap_pictextframe, $gap_pictextframe, 0, 0, $w + ($pic_border * 2), $h + ($pic_border * 2));
      
      // Nicht mehr bentigtes Bild lschen
      ImageDestroy ($img_photo);
  
      // Drehen
      $frameangle = intval($pluginParams->get('iig_css_image_frameangle', '0'));
      
      if ( $frameangle > 0 && $frameangle < 360) {
        $img = imagerotate($img, $frameangle, imagecolortransparent($img)); 
      }
  
      imagejpeg($img, $imgPath.'css.jpg', $pluginParams->get('iig_css_quality', 100));
  
      imagedestroy($img);    
    }
  }
  
  function imageResize($img, $width, $height, $ratio) {

    $imagedata["0"] = ImageSX($img);
    $imagedata["1"] = ImageSY($img);
    
    $new_w = $width;
    if ($ratio) {
      $new_h = (int)($imagedata[1]*($new_w/$imagedata[0]));
      if(($height) AND ($new_h > $height)) {
        $new_h = $height;
        $new_w = (int)($imagedata[0]*($new_h/$imagedata[1]));
      } 
    } else {
      $new_h = $height;
    }

    $img_new = imagecreatetruecolor($new_w, $new_h);

    imagecopyresampled($img_new, $img, 0, 0, 0, 0, $new_w, $new_h, $imagedata["0"], $imagedata["1"]);

    imagedestroy($img);

    return $img_new;
  }  
  
  function entenc($text) {
      $res = '';
      for ($i = 0; $i < strlen($text); $i++)
      {
          $cc = ord($text{$i});
          if ($cc >= 128 || $cc == 38)
              $res .= "&#$cc;";
          else
              $res .= chr($cc);
      }
      return $res;
  } 
  
  function ImageFontWidthByFilename($filename) {
    $handle = @fopen($filename,"r");
    $c_wid = @fread($handle,11); // 11 = Schriftgre ???? Nochmal testen
    @fclose($handle);
    return(ord($c_wid{8})+ord($c_wid{9})+ord($c_wid{10})+ord($c_wid{11}));
  }

  function calculateTextBox($font_size, $font_angle, $font_file, $text) { 
    $box   = imagettfbbox($font_size, $font_angle, $font_file, $text); 
    if( !$box ) 
      return false; 
    $min_x = min( array($box[0], $box[2], $box[4], $box[6]) ); 
    $max_x = max( array($box[0], $box[2], $box[4], $box[6]) ); 
    $min_y = min( array($box[1], $box[3], $box[5], $box[7]) ); 
    $max_y = max( array($box[1], $box[3], $box[5], $box[7]) ); 
    $width  = ( $max_x - $min_x ); 
    $height = ( $max_y - $min_y ); 
    $left   = abs( $min_x ) + $width; 
    $top    = abs( $min_y ) + $height; 
    // to calculate the exact bounding box i write the text in a large image 
    $img     = @imagecreatetruecolor( $width << 2, $height << 2 ); 
    $white   =  imagecolorallocate( $img, 255, 255, 255 ); 
    $black   =  imagecolorallocate( $img, 0, 0, 0 ); 
    imagefilledrectangle($img, 0, 0, imagesx($img), imagesy($img), $black); 
    // for sure the text is completely in the image! 
    imagettftext( $img, $font_size, 
                  $font_angle, $left, $top, 
                  $white, $font_file, $text); 
    // start scanning (0=> black => empty) 
    $rleft  = $w4 = $width<<2; 
    $rright = 0; 
    $rbottom   = 0; 
    $rtop = $h4 = $height<<2; 
    for( $x = 0; $x < $w4; $x++ ) 
      for( $y = 0; $y < $h4; $y++ ) 
        if( imagecolorat( $img, $x, $y ) ){ 
          $rleft   = min( $rleft, $x ); 
          $rright  = max( $rright, $x ); 
          $rtop    = min( $rtop, $y ); 
          $rbottom = max( $rbottom, $y ); 
        } 
    // destroy img and serve the result 
    imagedestroy( $img ); 
    return array("left"   => $left - $rleft, 
                  "top"    => $top  - $rtop, 
                  "width"  => $rright - $rleft + 1, 
                  "height" => $rbottom - $rtop + 1 ); 
  }   

?>